import java.math.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/
class Options {

  private static String T20 = "18567078082619935259" ;
  private static String T30 = "350243405507562291174415825999" ;
  private static String T40 = "5705979550618670446308578858542675373983" ;
  private static String T45 = "732197471686198597184965476425281169401188191" ;
  private static String T60 = "676292275716558246502605230897191366469551764092181362779759" ;
  private static String F7 ="340282366920938463463374607431768211457" ;
  private static String X50 = "911488677742604232220653108220238597860139579" ;
  BigInteger n = new BigInteger (T20) ;
  int B = 0 ;
  int T = 0 ;
  int F = 0 ;
  int verbose = 0 ;
  int S = 4 ;
  boolean simple = false ;
  int timeout = 0 ;

  private void usage(String prog) {
    System.err.println("Usage: java " + prog + " [options]* [n]") ;
    System.err.println("   n is some integer, a few symbolic names are reckognized (F7...)") ;
    System.err.println("Options are :") ;
    System.err.println("  -v, be verbose, can be repeated") ;
    System.err.println("  -B n, factor base limit") ;
    System.err.println("  -T n, size of sieving interval (in Ko)") ;
    System.err.println("  -S n, sieving applied to p >= 2^n (defaut "+ S + ")") ;
    System.err.println("  -F k, large prime variation for p <= k*B (default F=1 -> no large primes)") ;
    System.err.println("  -P sec, timeout for attempting factorization by Pollard's rho method  (default P=0 -> no Pollard)") ;
    System.exit(2) ;
  }

  
  Options(String prog, String [] argv) {
    int argi=0 ;
    while (argv[argi].charAt(0) == '-') {
      if (argv[argi].compareTo("-B") == 0) {
        B = Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-T") == 0) {
        T = 1024*Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-S") == 0) {
        S = Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-F") == 0) {
        F = Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-P") == 0) {
        timeout = 1000*Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-v") == 0) {
        verbose++ ;
      } else if (argv[argi].compareTo("-s") == 0) {
        simple = true ;
      } else {
        usage(prog) ;
      }
      argi++ ;
    }
    if (argi+1 == argv.length) {
      String arg = argv[argi] ;
      if (arg.equals("T20"))      arg = T20 ;
      else if (arg.equals("T30")) arg = T30 ;
      else if (arg.equals("T40")) arg = T40 ;
      else if (arg.equals("T45")) arg = T45 ;
      else if (arg.equals("T60")) arg = T60 ;
      else if (arg.equals("F7"))  arg = F7 ;
      else if (arg.equals("X50"))  arg = X50 ;
      n = new BigInteger(arg) ;
    } else {
      usage(prog) ;
      System.exit(2) ;
    }
  }
}
