/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/
class Table {
  private int [] t ;
  private int next ;

  Table () {
    t = new int [100] ;
    next = 0 ;
  }

  private void resize() {
    if (next >= t.length) {
      int [] newT = new int[2*t.length] ;
      for (int i = 0 ; i < next ; i++)
        newT[i] = t[i] ;
      t = newT ;
    }
  }

  void add(int x) {
    resize() ;
    t[next++] = x ;
  }


  void empty() {
    next = 0 ;
  }

  int [] trim() {
    int sz = next  ;
    int [] r = new int [sz] ;
    for (int i = 0 ; i < sz ; i++) {
      r[i] = t[i] ;
    }
    empty() ;
    return r ;
  }

  public String toString() {
    StringBuffer b = new StringBuffer () ;

    if (next > 0) {
      for (int i = 0 ; i < next-1 ; i++) {
        b.append(t[i]) ;
        b.append(' ') ;      
      }
      b.append(t[next-1]) ;
    }
    return b.toString() ;
  }
}
